import * as i0 from '@angular/core';
import { signal, computed, Component, Input, Pipe, EventEmitter, effect, ViewChild, Injector, createComponent, ApplicationRef, Injectable } from '@angular/core';
import { toSignal, toObservable } from '@angular/core/rxjs-interop';
import { map, fromEvent, from, filter, switchMap, combineLatest, firstValueFrom } from 'rxjs';
import { style, animate, transition, trigger } from '@angular/animations';
import { TemplatePortal } from '@angular/cdk/portal';
import { NgClass, JsonPipe } from '@angular/common';
import { takeUntil } from 'rxjs/operators';
import * as i2 from '@angular/cdk/overlay';

class ArrowComponent {
    constructor() {
        this._direction = signal(undefined);
        this.pathData = computed(() => {
            const direction = this._direction();
            let fromX = 0, fromY = 0, toX = 0, toY = 0, controlPointX = 0, controlPointY = 0;
            switch (direction) {
                case 'top':
                    fromX = 50;
                    fromY = 0;
                    toX = 50;
                    toY = 100;
                    controlPointX = 50;
                    controlPointY = 50;
                    break;
                case 'bottom':
                    fromX = 50;
                    fromY = 100;
                    toX = 50;
                    toY = 0;
                    controlPointX = 50;
                    controlPointY = 50;
                    break;
                case 'left':
                    fromX = 0;
                    fromY = 0;
                    toX = 100;
                    toY = 50;
                    controlPointX = 0;
                    controlPointY = 50;
                    break;
                case 'right':
                    fromX = 100;
                    fromY = 0;
                    toX = 0;
                    toY = 50;
                    controlPointX = 100;
                    controlPointY = 50;
                    break;
            }
            return `M${fromX},${fromY} Q${controlPointX},${controlPointY} ${toX},${toY}`;
        });
    }
    get direction() {
        return this._direction();
    }
    set direction(value) {
        this._direction.set(value);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ArrowComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.0.8", type: ArrowComponent, isStandalone: true, selector: "lib-arrow", inputs: { direction: "direction" }, ngImport: i0, template: `
    <svg viewBox="-10 -10 110 110">
      <defs>
        <marker
          id="arrowMarker"
          viewBox="0 0 36 21"
          refX="21"
          refY="10"
          markerUnits="strokeWidth"
          orient="auto"
          markerWidth="16"
          markerHeight="12"
        >
          <path id="polyline" d="M0,0 c30,11 30,9 0,20" />
        </marker>
      </defs>
      <path [attr.d]="pathData()" marker-end="url(#arrowMarker)" />
    </svg>
  `, isInline: true, styles: [":host{display:block;width:100px;height:100px}path{fill:none;stroke:#fff;stroke-width:2}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ArrowComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-arrow', standalone: true, template: `
    <svg viewBox="-10 -10 110 110">
      <defs>
        <marker
          id="arrowMarker"
          viewBox="0 0 36 21"
          refX="21"
          refY="10"
          markerUnits="strokeWidth"
          orient="auto"
          markerWidth="16"
          markerHeight="12"
        >
          <path id="polyline" d="M0,0 c30,11 30,9 0,20" />
        </marker>
      </defs>
      <path [attr.d]="pathData()" marker-end="url(#arrowMarker)" />
    </svg>
  `, styles: [":host{display:block;width:100px;height:100px}path{fill:none;stroke:#fff;stroke-width:2}\n"] }]
        }], propDecorators: { direction: [{
                type: Input
            }] } });

class ForceFieldComponent {
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ForceFieldComponent, deps: [], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "17.0.8", type: ForceFieldComponent, isStandalone: true, selector: "lib-force-field", inputs: { size: "size", position: "position" }, host: { properties: { "style.width": "size.width + \"px\"", "style.height": "size.height + \"px\"", "style.minWidth": "size.width + \"px\"", "style.minHeight": "size.height + \"px\"", "style.maxWidth": "size.width + \"px\"", "style.maxHeight": "size.height + \"px\"", "style.top": "position.y + \"px\"", "style.left": "position.x + \"px\"" } }, ngImport: i0, template: ``, isInline: true, styles: [":host{display:block;background-color:#000;position:fixed;transition:top .5s ease-in-out,left .5s ease-in-out}\n"] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: ForceFieldComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-force-field', standalone: true, template: ``, host: {
                        '[style.width]': 'size.width + "px"',
                        '[style.height]': 'size.height + "px"',
                        '[style.minWidth]': 'size.width + "px"',
                        '[style.minHeight]': 'size.height + "px"',
                        '[style.maxWidth]': 'size.width + "px"',
                        '[style.maxHeight]': 'size.height + "px"',
                        '[style.top]': 'position.y + "px"',
                        '[style.left]': 'position.x + "px"',
                    }, styles: [":host{display:block;background-color:#000;position:fixed;transition:top .5s ease-in-out,left .5s ease-in-out}\n"] }]
        }], propDecorators: { size: [{
                type: Input
            }], position: [{
                type: Input
            }] } });

class Elements {
    get appRoot() {
        return document.querySelector('[ng-version]');
    }
    get body() {
        return document.body;
    }
}
function provideWindow() {
    return { provide: Window, useValue: window };
}

function getDirection(position) {
    if (!position) {
        return undefined;
    }
    if (position.originX === 'start' && position.originY === 'center') {
        return 'left';
    }
    if (position.originX === 'end' && position.originY === 'center') {
        return 'right';
    }
    if (position.originX === 'center' && position.originY === 'top') {
        return 'top';
    }
    if (position.originX === 'center' && position.originY === 'bottom') {
        return 'bottom';
    }
    console.warn('Unknown position', position);
    return undefined;
}
class DirectionPipe {
    transform(position) {
        return getDirection(position);
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: DirectionPipe, deps: [], target: i0.ɵɵFactoryTarget.Pipe }); }
    static { this.ɵpipe = i0.ɵɵngDeclarePipe({ minVersion: "14.0.0", version: "17.0.8", ngImport: i0, type: DirectionPipe, isStandalone: true, name: "direction" }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: DirectionPipe, decorators: [{
            type: Pipe,
            args: [{
                    name: 'direction',
                    standalone: true,
                    pure: true,
                }]
        }] });

const rightCenter = {
    // right center
    originX: 'end',
    overlayX: 'start',
    originY: 'center',
    overlayY: 'center',
};
const rightTop = {
    // right top
    originX: 'end',
    overlayX: 'start',
    originY: 'top',
    overlayY: 'bottom',
};
const rightBottom = {
    // right bottom
    originX: 'end',
    overlayX: 'start',
    originY: 'bottom',
    overlayY: 'top',
};
const leftCenter = {
    // left center
    originX: 'start',
    overlayX: 'end',
    originY: 'center',
    overlayY: 'center',
};
const leftTop = {
    // left top
    originX: 'start',
    overlayX: 'end',
    originY: 'top',
    overlayY: 'bottom',
};
const leftBottom = {
    // left bottom
    originX: 'start',
    overlayX: 'end',
    originY: 'bottom',
    overlayY: 'top',
};
const topCenter = {
    // top center
    originX: 'center',
    overlayX: 'center',
    originY: 'top',
    overlayY: 'bottom',
};
const bottomCenter = {
    // bottom center
    originX: 'center',
    overlayX: 'center',
    originY: 'bottom',
    overlayY: 'top',
};
const ALL_POSITIONS = [
    rightCenter,
    rightTop,
    rightBottom,
    leftCenter,
    leftTop,
    leftBottom,
    topCenter,
    bottomCenter,
];
const ALL_SIDES = [rightCenter, leftCenter, topCenter, bottomCenter];

class EnjoyHintRef {
    constructor(tutorial, options = {}) {
        this.tutorial = tutorial;
        this.options = options;
        this.onClose = new EventEmitter();
    }
    close() {
        this.onClose.emit();
    }
}

class TutorialComponent {
    static { this.defaultOptions = {
        padding: 5,
        fontFamily: 'sans-serif',
        backdropColor: 'black'
    }; }
    constructor(ref, window, overlayPositionBuilder, overlay, viewContainerRef, destroyedRef, zone) {
        this.ref = ref;
        this.overlayPositionBuilder = overlayPositionBuilder;
        this.overlay = overlay;
        this.viewContainerRef = viewContainerRef;
        this.destroyedRef = destroyedRef;
        this.zone = zone;
        this.animating = signal(false);
        this.focusElement = computed(() => {
            const step = this.ref.tutorial.step();
            if (!step) {
                return null;
            }
            return document.querySelector(step.selector);
        });
        this.elementBounds = computed(() => {
            const element = this.focusElement();
            if (!element) {
                return {
                    x: 0,
                    y: 0,
                    width: 0,
                    height: 0,
                };
            }
            return element.getBoundingClientRect();
        });
        this.ffPositions = computed(() => {
            const bounds = this.elementBounds();
            const size = this.forceFieldSize();
            return {
                left: {
                    x: -1 * size.width + bounds.x - this.options.padding,
                    y: 0,
                },
                right: {
                    x: bounds.x + bounds.width + this.options.padding,
                    y: 0,
                },
                top: {
                    x: 0,
                    y: -1 * size.height + bounds.y - this.options.padding,
                },
                bottom: {
                    x: 0,
                    y: bounds.y + bounds.height + this.options.padding,
                },
            };
        });
        this.step = computed(() => this.ref.tutorial.step());
        this.overlayRef = null;
        this.positionStrategy = computed(() => {
            const element = this.focusElement();
            if (!element) {
                return null;
            }
            return this.overlayPositionBuilder
                .flexibleConnectedTo(element)
                .withFlexibleDimensions(false)
                .withPositions(ALL_SIDES);
        });
        this.position = signal(undefined);
        this.options = {
            ...TutorialComponent.defaultOptions,
            ...ref.options,
        };
        const getSize = () => ({
            width: window.innerWidth,
            height: window.innerHeight,
        });
        this.forceFieldSize = toSignal(fromEvent(window, 'resize').pipe(map(getSize)), { initialValue: getSize() });
        this.thisIsDestroyed = from(new Promise((resolve) => this.destroyedRef.onDestroy(() => resolve())));
        combineLatest([toObservable(this.focusElement), toObservable(this.step)])
            .pipe(takeUntil(this.thisIsDestroyed), filter(([e, s]) => !!e && !!s), switchMap(([element, step]) => fromEvent(element, step.event)))
            .subscribe(() => {
            this.ref.tutorial.nextStep();
            if (!this.step()) {
                this.close();
            }
        });
        effect(() => {
            this.step(); // even though we don't use it, this is how we make the effect dependent on the step
            const overlayRef = this.overlayRef;
            overlayRef?.detach();
            overlayRef?.dispose();
            this.animating.set(true);
            setTimeout(() => this.createOverlay(), 750);
        }, { allowSignalWrites: true });
    }
    createOverlay() {
        const step = this.step();
        const element = this.focusElement();
        const positionStrategy = this.positionStrategy();
        if (!element || !step || !positionStrategy) {
            return;
        }
        positionStrategy.positionChanges
            .pipe(takeUntil(this.thisIsDestroyed))
            .subscribe((x) => {
            this.zone.run(() => this.position.set(x.connectionPair));
        });
        const overlayRef = this.overlay.create({
            positionStrategy,
            hasBackdrop: false,
        });
        const overlayComponent = new TemplatePortal(this.instructions, this.viewContainerRef);
        overlayRef.attach(overlayComponent);
        this.overlayRef = overlayRef;
        this.animating.set(false);
    }
    previous() {
        this.ref.tutorial.previousStep();
    }
    next() {
        this.ref.tutorial.nextStep();
    }
    skip() {
        this.close();
    }
    close() {
        this.ref.close();
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: TutorialComponent, deps: [{ token: EnjoyHintRef }, { token: Window }, { token: i2.OverlayPositionBuilder }, { token: i2.Overlay }, { token: i0.ViewContainerRef }, { token: i0.DestroyRef }, { token: i0.NgZone }], target: i0.ɵɵFactoryTarget.Component }); }
    static { this.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "17.0.0", version: "17.0.8", type: TutorialComponent, isStandalone: true, selector: "lib-ng-enjoyhint-lib", providers: [provideWindow()], viewQueries: [{ propertyName: "instructions", first: true, predicate: ["instructions"], descendants: true }], ngImport: i0, template: "@if (ffPositions(); as positions) {\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.top\"\n></lib-force-field>\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.left\"\n></lib-force-field>\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.right\"\n></lib-force-field>\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.bottom\"\n></lib-force-field>\n}\n\n<ng-template #instructions>\n  <div\n    class=\"instructions\"\n    @fadeIn\n    [ngClass]=\"{\n    top: (position() | direction) === 'top',\n    left: (position() | direction) === 'left',\n    right: (position() | direction) === 'right',\n    bottom: (position() | direction) === 'bottom',\n  }\"\n  >\n    <label [style.fontFamily]=\"options.fontFamily\">\n      {{ step()?.description }}\n    </label>\n    <lib-arrow [direction]=\"position() | direction\"></lib-arrow>\n    <div class=\"buttons\">\n      @if (ref.tutorial.hasPrevious()) {\n      <button (click)=\"previous()\" [style.fontFamily]=\"options.fontFamily\">\n        Previous\n      </button>\n      } @if (step()?.event === 'next') {\n      <button (click)=\"next()\" [style.fontFamily]=\"options.fontFamily\">\n        Next\n      </button>\n      }\n      <button (click)=\"skip()\" [style.fontFamily]=\"options.fontFamily\">\n        Skip\n      </button>\n    </div>\n  </div>\n</ng-template>\n", styles: [":host{opacity:.5}label{color:#fff;font-size:2em}.instructions{display:grid;grid-template-rows:repeat(3,auto);grid-template-columns:auto;gap:.5rem;justify-content:start;justify-items:start;padding:.75rem}.instructions label{grid-column:1;grid-row:1}.instructions lib-arrow{grid-column:1;grid-row:2}.instructions .buttons{grid-column:1;grid-row:3}.instructions.left{justify-content:end;justify-items:end}.instructions.right{justify-content:start;justify-items:start}.instructions.top{justify-content:center;justify-items:center}.instructions.top .buttons{grid-row:1}.instructions.top label{grid-row:2}.instructions.top lib-arrow{grid-row:3}.instructions.bottom{justify-content:center;justify-items:center}.instructions.bottom lib-arrow{grid-row:1}.instructions.bottom label{grid-row:2}.instructions.bottom .buttons{grid-row:3}.buttons{display:flex;flex-direction:row;gap:.5rem}.buttons button{background-color:transparent;border:1px solid white;border-radius:5px;color:#fff;font-size:.75rem;width:5rem;padding:.5rem;transition:all .25s ease-in-out;cursor:pointer}.buttons button:hover{background-color:#fff;color:#000}\n"], dependencies: [{ kind: "component", type: ForceFieldComponent, selector: "lib-force-field", inputs: ["size", "position"] }, { kind: "component", type: ArrowComponent, selector: "lib-arrow", inputs: ["direction"] }, { kind: "directive", type: NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "pipe", type: DirectionPipe, name: "direction" }], animations: [
            trigger('fadeIn', [
                transition(':enter', [style({ opacity: 0 }), animate(500)]),
            ]),
        ] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: TutorialComponent, decorators: [{
            type: Component,
            args: [{ selector: 'lib-ng-enjoyhint-lib', standalone: true, imports: [
                        ForceFieldComponent,
                        ArrowComponent,
                        JsonPipe,
                        NgClass,
                        DirectionPipe,
                    ], animations: [
                        trigger('fadeIn', [
                            transition(':enter', [style({ opacity: 0 }), animate(500)]),
                        ]),
                    ], providers: [provideWindow()], template: "@if (ffPositions(); as positions) {\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.top\"\n></lib-force-field>\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.left\"\n></lib-force-field>\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.right\"\n></lib-force-field>\n<lib-force-field\n  [size]=\"forceFieldSize()\"\n  [position]=\"positions.bottom\"\n></lib-force-field>\n}\n\n<ng-template #instructions>\n  <div\n    class=\"instructions\"\n    @fadeIn\n    [ngClass]=\"{\n    top: (position() | direction) === 'top',\n    left: (position() | direction) === 'left',\n    right: (position() | direction) === 'right',\n    bottom: (position() | direction) === 'bottom',\n  }\"\n  >\n    <label [style.fontFamily]=\"options.fontFamily\">\n      {{ step()?.description }}\n    </label>\n    <lib-arrow [direction]=\"position() | direction\"></lib-arrow>\n    <div class=\"buttons\">\n      @if (ref.tutorial.hasPrevious()) {\n      <button (click)=\"previous()\" [style.fontFamily]=\"options.fontFamily\">\n        Previous\n      </button>\n      } @if (step()?.event === 'next') {\n      <button (click)=\"next()\" [style.fontFamily]=\"options.fontFamily\">\n        Next\n      </button>\n      }\n      <button (click)=\"skip()\" [style.fontFamily]=\"options.fontFamily\">\n        Skip\n      </button>\n    </div>\n  </div>\n</ng-template>\n", styles: [":host{opacity:.5}label{color:#fff;font-size:2em}.instructions{display:grid;grid-template-rows:repeat(3,auto);grid-template-columns:auto;gap:.5rem;justify-content:start;justify-items:start;padding:.75rem}.instructions label{grid-column:1;grid-row:1}.instructions lib-arrow{grid-column:1;grid-row:2}.instructions .buttons{grid-column:1;grid-row:3}.instructions.left{justify-content:end;justify-items:end}.instructions.right{justify-content:start;justify-items:start}.instructions.top{justify-content:center;justify-items:center}.instructions.top .buttons{grid-row:1}.instructions.top label{grid-row:2}.instructions.top lib-arrow{grid-row:3}.instructions.bottom{justify-content:center;justify-items:center}.instructions.bottom lib-arrow{grid-row:1}.instructions.bottom label{grid-row:2}.instructions.bottom .buttons{grid-row:3}.buttons{display:flex;flex-direction:row;gap:.5rem}.buttons button{background-color:transparent;border:1px solid white;border-radius:5px;color:#fff;font-size:.75rem;width:5rem;padding:.5rem;transition:all .25s ease-in-out;cursor:pointer}.buttons button:hover{background-color:#fff;color:#000}\n"] }]
        }], ctorParameters: () => [{ type: EnjoyHintRef }, { type: Window }, { type: i2.OverlayPositionBuilder }, { type: i2.Overlay }, { type: i0.ViewContainerRef }, { type: i0.DestroyRef }, { type: i0.NgZone }], propDecorators: { instructions: [{
                type: ViewChild,
                args: ['instructions']
            }] } });

class Tutorial {
    constructor(steps) {
        this.steps = steps;
        this._stepIndex = signal(0);
        this.stepIndex = this._stepIndex.asReadonly();
        this.step = computed(() => this.steps[this.stepIndex()]);
        this.hasPrevious = computed(() => this.stepIndex() > 0);
    }
    reset() {
        this._stepIndex.set(0);
    }
    setStepIndex(index) {
        const normalizedIndex = Math.max(0, Math.min(index, this.steps.length - 1));
        this._stepIndex.set(normalizedIndex);
    }
    nextStep() {
        this._stepIndex.update((index) => index + 1);
    }
    previousStep() {
        this._stepIndex.update((index) => index - 1);
    }
}

class EnjoyhintService {
    constructor(appRef, elements, originalOverflow) {
        this.appRef = appRef;
        this.elements = elements;
        this.originalOverflow = originalOverflow;
    }
    async runTutorial(steps, options) {
        const appRoot = this.elements.appRoot;
        if (!appRoot) {
            throw new Error('Root element not found');
        }
        const tutorial = new Tutorial(steps);
        const ref = new EnjoyHintRef(tutorial, options);
        const componentInstance = createComponent(TutorialComponent, {
            elementInjector: Injector.create({
                providers: [{ provide: EnjoyHintRef, useValue: ref }],
            }),
            environmentInjector: this.appRef.injector,
        });
        try {
            this.elements.body.style.overflow = 'hidden';
            this.appRef.attachView(componentInstance.hostView);
            appRoot.appendChild(componentInstance.location.nativeElement);
            await firstValueFrom(ref.onClose);
        }
        finally {
            this.elements.body.style.overflow = this.originalOverflow;
            componentInstance.destroy();
        }
    }
    static { this.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: EnjoyhintService, deps: "invalid", target: i0.ɵɵFactoryTarget.Injectable }); }
    static { this.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: EnjoyhintService, providedIn: 'root', useFactory: (appRef) => new EnjoyhintService(appRef, new Elements(), getComputedStyle(document.body).overflow), deps: [{ token: ApplicationRef }] }); }
}
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "17.0.8", ngImport: i0, type: EnjoyhintService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                    deps: [ApplicationRef],
                    useFactory: (appRef) => new EnjoyhintService(appRef, new Elements(), getComputedStyle(document.body).overflow),
                }]
        }], ctorParameters: () => [{ type: i0.ApplicationRef }, { type: Elements }, { type: undefined }] });

/*
 * Public API Surface of ng-enjoyhint-lib
 */

/**
 * Generated bundle index. Do not edit.
 */

export { EnjoyhintService };
//# sourceMappingURL=ng-enjoyhint.mjs.map
